//************************************************************
//  University of Patras 
//	Department of Electrical Engineering & Computer Technology
//	 
//	Course: Parallel Programming in AI 
//	Week 02: Simple parallel programming methods
//
//  Problem: Multiple forks in three levels 
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc fork02.c -o fork02
Executing:	./fork02
Output in my laptop:

Before forks
After first fork A Level1: 8060
   Inside parent Level1-A: 8060
   Forks  B and C will never reach this code
After first fork A Level1: 0
   Inside child A Level1: 0
   Inside fork D Level2: 8060 8061
   Inside fork D Level2: 8060 0
          Inside child A fork B Level2: 0 8062
          Inside child A fork B Level2: 0 0
               Inside fork C Level3: 0 8062 8063
               Inside fork C Level3: 0 0 8064
               Inside fork C Level3: 0 8062 0
               Inside fork C Level3: 0 0 0

*********************************************************************
*/

// *******************************************************************
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

// *******************************************************************
int main() {
    pid_t pid1 = -1, pid2 = -2, pid3 = -3;
    printf( "Before forks\n") ;
    pid1 = fork(); // *********** A *******************
    printf( "After first fork A Level1: %d\n", pid1 ) ;
    if(pid1 == 0){
        printf( "   Inside child A Level1: %d\n", pid1 ) ;
        pid2=fork(); // *********** B *****************
        printf( "          Inside child A fork B Level2: %d %d\n", pid1,pid2 ) ;
        pid3=fork(); // *********** C *****************
        printf( "               Inside fork C Level3: %d %d %d\n", pid1,pid2, pid3 ) ;
    } else {
        printf( "   Inside parent Level1-A: %d\n", pid1 ) ;
        printf( "   Forks  B and C will never reach this code\n" ) ;
        pid3=fork(); // *********** D *****************
        printf( "   Inside fork D Level2: %d %d\n", pid1, pid3 ) ;
    }
    return 0;
}
