//************************************************************
//  University of Patras 
//	Department of Electrical Engineering & Computer Technology
//	 
//	Course: Parallel Programming in AI 
//	Week 02: Simple parallel programming methods
//
//  Problem: How many prime numbers are in [I1,I2) ? 
//  	primes03.cpp: Sieve of Eratosthenes (Η σίτα του Ερατοσθένη)
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
g++ -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc primes02.c -o primes02 -lm
Executing:	time ./primes02 3 10000000 
Output in my laptop:
664578
real	0m4.846s
user	0m4.846s
sys	    0m0.000s
*********************************************************************
Compiling:	gcc primes02.c -o primes02 -lm -O2
Executing:	time ./primes02 3 10000000 
Output in my laptop:
664578
real	0m4.742s
user	0m4.728s
sys	    0m0.012s
*********************************************************************
Compiling:	icc primes01.c -o primes01 -lm 
Executing:	time ./primes02 3 10000000 
Output in my laptop:
time ./primes01 3 10000000
664578
real	0m4.738s
user	0m4.738s
sys 	0m0.000s
*********************************************************************
*/

// *******************************************************************
#include <iostream>
#include <bits/stdc++.h> 

using namespace std; 
  
// **********************************************************
int primes( int min, int Max ) 
{ 
    bool P[Max]; 
    memset(P, true, sizeof(P)); 
  
    // Build the Sieve of Eratosthenes 
    for (int p = 2; p*p < Max; p++) { 
          if (P[p] == true) { 
            for (int i = p*2; i < Max; i += p) 
                P[i] = false; 
        } 
    } 
  
    // Count in the Sieve of Eratosthenes 
    int s = 0 ; 
    for (int i = (min|1) ; i < Max; i += 2) { 
        if ( P[i] == true ) 
            s++; 
    } 
    return s ;
} 

// *******************************************************************
int main(int argc, char *argv[]) 
{ 
    int m, M, res ;

    if ( argc < 3)
        return -1 ;
    else {
        if ((m=atoi(argv[1]))<3 )
            return -2 ;
        if ((M=atoi(argv[2]))<3 )
            return -2 ;
    }
    res = primes(m,M) ;
    cout << "Number of Primes in [" << m << "," << M << "] is " << res << endl ;

	return 0; 
} 
